#pragma once

#include "targetver.h"

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <d3d9.h>
#include <d3dx9tex.h>
#include <stdio.h>

#include <algorithm>
#include <sstream>
#include <fstream>

inline void *DetourFunc(BYTE *src, const BYTE *dst, const int len)
{
	BYTE *jmp = (BYTE*)malloc(len+5);
	DWORD dwback;

	VirtualProtect(src, len, PAGE_READWRITE, &dwback);

	memcpy(jmp, src, len);	jmp += len;

	jmp[0] = 0xE9;
	*(DWORD*)(jmp+1) = (DWORD)(src+len - jmp) - 5;

	src[0] = 0xE9;
	*(DWORD*)(src+1) = (DWORD)(dst-src) - 5;

	VirtualProtect(src, len, dwback, &dwback);

	return jmp-len;
}

inline bool RetourFunc(BYTE *src, BYTE *restore, const int len)
{
	DWORD dwback;

	if (!VirtualProtect(src, len, PAGE_READWRITE, &dwback))
		return false;
	if (!memcpy(src, restore, len))
		return false;

	restore[0] = 0xE9;
	*(DWORD*)(restore+1) = (DWORD)(src - restore) - 5;

	if (!VirtualProtect(src, len, dwback, &dwback))
		return false;

	return true;
}
